Index: include/avr/iomxx4.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iomxx4.h,v
retrieving revision 1.18
diff -u -r1.18 iomxx4.h
--- include/avr/iomxx4.h	6 Feb 2009 23:31:45 -0000	1.18
+++ include/avr/iomxx4.h	26 Mar 2009 20:10:35 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2005, 2006, 2007 Anatoly Sokolov
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -733,110 +734,137 @@
 /* Interrupt vectors */
 /* Vector 0 is the reset vector */
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt Request 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* External Interrupt Request 2 */
+#define INT2_num 			3
 #define INT2_vect			_VECTOR(3)
 #define SIG_INTERRUPT2			_VECTOR(3)
 
 /* Pin Change Interrupt Request 0 */
+#define PCINT0_num 			4
 #define PCINT0_vect			_VECTOR(4)
 #define SIG_PIN_CHANGE0			_VECTOR(4)
 
 /* Pin Change Interrupt Request 1 */
+#define PCINT1_num 			5
 #define PCINT1_vect			_VECTOR(5)
 #define SIG_PIN_CHANGE1			_VECTOR(5)
 
 /* Pin Change Interrupt Request 2 */
+#define PCINT2_num 			6
 #define PCINT2_vect			_VECTOR(6)
 #define SIG_PIN_CHANGE2			_VECTOR(6)
 
 /* Pin Change Interrupt Request 3 */
+#define PCINT3_num 			7
 #define PCINT3_vect			_VECTOR(7)
 #define SIG_PIN_CHANGE3			_VECTOR(7)
 
 /* Watchdog Time-out Interrupt */
+#define WDT_num 			8
 #define WDT_vect			_VECTOR(8)
 #define SIG_WATCHDOG_TIMEOUT		_VECTOR(8)
 
 /* Timer/Counter2 Compare Match A */
+#define TIMER2_COMPA_num 		9
 #define TIMER2_COMPA_vect		_VECTOR(9)
 #define SIG_OUTPUT_COMPARE2A		_VECTOR(9)
 
 /* Timer/Counter2 Compare Match B */
+#define TIMER2_COMPB_num 		10
 #define TIMER2_COMPB_vect		_VECTOR(10)
 #define SIG_OUTPUT_COMPARE2B		_VECTOR(10)
 
 /* Timer/Counter2 Overflow */
+#define TIMER2_OVF_num 			11
 #define TIMER2_OVF_vect			_VECTOR(11)
 #define SIG_OVERFLOW2			_VECTOR(11)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		12
 #define TIMER1_CAPT_vect		_VECTOR(12)
 #define SIG_INPUT_CAPTURE1		_VECTOR(12)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		13
 #define TIMER1_COMPA_vect		_VECTOR(13)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(13)
 
 /* Timer/Counter1 Compare Match B */
+#define TIMER1_COMPB_num 		14
 #define TIMER1_COMPB_vect		_VECTOR(14)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(14)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			15
 #define TIMER1_OVF_vect			_VECTOR(15)
 #define SIG_OVERFLOW1			_VECTOR(15)
 
 /* Timer/Counter0 Compare Match A */
+#define TIMER0_COMPA_num 		16
 #define TIMER0_COMPA_vect		_VECTOR(16)
 #define SIG_OUTPUT_COMPARE0A		_VECTOR(16)
 
 /* Timer/Counter0 Compare Match B */
+#define TIMER0_COMPB_num 		17
 #define TIMER0_COMPB_vect		_VECTOR(17)
 #define SIG_OUTPUT_COMPARE0B		_VECTOR(17)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			18
 #define TIMER0_OVF_vect			_VECTOR(18)
 #define SIG_OVERFLOW0			_VECTOR(18)
 
 /* SPI Serial Transfer Complete */
+#define SPI_STC_num 			19
 #define SPI_STC_vect			_VECTOR(19)
 #define SIG_SPI				_VECTOR(19)
 
 /* USART0, Rx Complete */
+#define USART0_RX_num 			20
 #define USART0_RX_vect			_VECTOR(20)
 #define SIG_USART_RECV			_VECTOR(20)
 
 /* USART0 Data register Empty */
+#define USART0_UDRE_num 		21
 #define USART0_UDRE_vect		_VECTOR(21)
 #define SIG_USART_DATA			_VECTOR(21)
 
 /* USART0, Tx Complete */
+#define USART0_TX_num 			22
 #define USART0_TX_vect			_VECTOR(22)
 #define SIG_USART_TRANS			_VECTOR(22)
 
 /* Analog Comparator */
+#define ANALOG_COMP_num 		23
 #define ANALOG_COMP_vect		_VECTOR(23)
 #define SIG_COMPARATOR			_VECTOR(23)
 
 /* ADC Conversion Complete */
+#define ADC_num 			24
 #define ADC_vect			_VECTOR(24)
 #define SIG_ADC				_VECTOR(24)
 
 /* EEPROM Ready */
+#define EE_READY_num 			25
 #define EE_READY_vect			_VECTOR(25)
 #define SIG_EEPROM_READY		_VECTOR(25)
 
 /* 2-wire Serial Interface */
+#define TWI_num 			26
 #define TWI_vect			_VECTOR(26)
 #define SIG_2WIRE_SERIAL		_VECTOR(26)
 
 /* Store Program Memory Read */
+#define SPM_READY_num 			27
 #define SPM_READY_vect			_VECTOR(27)
 #define SIG_SPM_READY			_VECTOR(27)
 
@@ -848,16 +876,19 @@
 
 /* USART1, Rx Complete */
 /* USART1 RX complete */
+#define USART1_RX_num 			28
 #define USART1_RX_vect			_VECTOR(28)
 #define SIG_USART1_RECV			_VECTOR(28)
 
 /* USART1 Data register Empty */
 /* USART1 Data Register Empty */
+#define USART1_UDRE_num 		29
 #define USART1_UDRE_vect		_VECTOR(29)
 #define SIG_USART1_DATA			_VECTOR(29)
 
 /* USART1, Tx Complete */
 /* USART1 TX complete */
+#define USART1_TX_num 			30
 #define USART1_TX_vect			_VECTOR(30)
 #define SIG_USART1_TRANS		_VECTOR(30)
 
@@ -866,4 +897,326 @@
 #endif /* defined(__AVR_ATmega644__) */
 
 
+/* Device Pin Definitions */
+#define DDR_ADC0  	DDRA
+#define PORT_ADC0 	PORTA
+#define PIN_ADC0  	PINA
+#define ADC0_IDX  	0
+
+#define DDR_PCINT0  	DDRA
+#define PORT_PCINT0 	PORTA
+#define PIN_PCINT0  	PINA
+#define PCINT0_IDX  	0
+
+#define DDR_ADC1  	DDRA
+#define PORT_ADC1 	PORTA
+#define PIN_ADC1  	PINA
+#define ADC1_IDX  	1
+
+#define DDR_PCINT1  	DDRA
+#define PORT_PCINT1 	PORTA
+#define PIN_PCINT1  	PINA
+#define PCINT1_IDX  	1
+
+#define DDR_ADC2  	DDRA
+#define PORT_ADC2 	PORTA
+#define PIN_ADC2  	PINA
+#define ADC2_IDX  	2
+
+#define DDR_PCINT2  	DDRA
+#define PORT_PCINT2 	PORTA
+#define PIN_PCINT2  	PINA
+#define PCINT2_IDX  	2
+
+#define DDR_ADC3  	DDRA
+#define PORT_ADC3 	PORTA
+#define PIN_ADC3  	PINA
+#define ADC3_IDX  	3
+
+#define DDR_PCINT3  	DDRA
+#define PORT_PCINT3 	PORTA
+#define PIN_PCINT3  	PINA
+#define PCINT3_IDX  	3
+
+#define DDR_ADC4  	DDRA
+#define PORT_ADC4 	PORTA
+#define PIN_ADC4  	PINA
+#define ADC4_IDX  	4
+
+#define DDR_PCINT4  	DDRA
+#define PORT_PCINT4 	PORTA
+#define PIN_PCINT4  	PINA
+#define PCINT4_IDX  	4
+
+#define DDR_ADC5  	DDRA
+#define PORT_ADC5 	PORTA
+#define PIN_ADC5  	PINA
+#define ADC5_IDX  	5
+
+#define DDR_PCINT5  	DDRA
+#define PORT_PCINT5 	PORTA
+#define PIN_PCINT5  	PINA
+#define PCINT5_IDX  	5
+
+#define DDR_ADC6  	DDRA
+#define PORT_ADC6 	PORTA
+#define PIN_ADC6  	PINA
+#define ADC6_IDX  	6
+
+#define DDR_PCINT6  	DDRA
+#define PORT_PCINT6 	PORTA
+#define PIN_PCINT6  	PINA
+#define PCINT6_IDX  	6
+
+#define DDR_ADC7  	DDRA
+#define PORT_ADC7 	PORTA
+#define PIN_ADC7  	PINA
+#define ADC7_IDX  	7
+
+#define DDR_PCINT7  	DDRA
+#define PORT_PCINT7 	PORTA
+#define PIN_PCINT7  	PINA
+#define PCINT7_IDX  	7
+
+#define DDR_XCK  	DDRB
+#define PORT_XCK 	PORTB
+#define PIN_XCK  	PINB
+#define XCK_IDX  	0
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	0
+
+#define DDR_PCINT9  	DDRB
+#define PORT_PCINT9 	PORTB
+#define PIN_PCINT9  	PINB
+#define PCINT9_IDX  	0
+
+#define DDR_T1  	DDRB
+#define PORT_T1 	PORTB
+#define PIN_T1  	PINB
+#define T1_IDX  	1
+
+#define DDR_CLKO  	DDRB
+#define PORT_CLKO 	PORTB
+#define PIN_CLKO  	PINB
+#define CLKO_IDX  	1
+
+#define DDR_PCINT9  	DDRB
+#define PORT_PCINT9 	PORTB
+#define PIN_PCINT9  	PINB
+#define PCINT9_IDX  	1
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	2
+
+#define DDR_INT2  	DDRB
+#define PORT_INT2 	PORTB
+#define PIN_INT2  	PINB
+#define INT2_IDX  	2
+
+#define DDR_PCINT10  	DDRB
+#define PORT_PCINT10 	PORTB
+#define PIN_PCINT10  	PINB
+#define PCINT10_IDX  	2
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	3
+
+#define DDR_OC0A  	DDRB
+#define PORT_OC0A 	PORTB
+#define PIN_OC0A  	PINB
+#define OC0A_IDX  	3
+
+#define DDR_PCINT11  	DDRB
+#define PORT_PCINT11 	PORTB
+#define PIN_PCINT11  	PINB
+#define PCINT11_IDX  	3
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	4
+
+#define DDR_OC0B  	DDRB
+#define PORT_OC0B 	PORTB
+#define PIN_OC0B  	PINB
+#define OC0B_IDX  	4
+
+#define DDR_PCINT12  	DDRB
+#define PORT_PCINT12 	PORTB
+#define PIN_PCINT12  	PINB
+#define PCINT12_IDX  	4
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	5
+
+#define DDR_PCINT13  	DDRB
+#define PORT_PCINT13 	PORTB
+#define PIN_PCINT13  	PINB
+#define PCINT13_IDX  	5
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	6
+
+#define DDR_PCINT14  	DDRB
+#define PORT_PCINT14 	PORTB
+#define PIN_PCINT14  	PINB
+#define PCINT14_IDX  	6
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	7
+
+#define DDR_PCINT15  	DDRB
+#define PORT_PCINT15 	PORTB
+#define PIN_PCINT15  	PINB
+#define PCINT15_IDX  	7
+
+#define DDR_SCL  	DDRC
+#define PORT_SCL 	PORTC
+#define PIN_SCL  	PINC
+#define SCL_IDX  	0
+
+#define DDR_PCINT16  	DDRC
+#define PORT_PCINT16 	PORTC
+#define PIN_PCINT16  	PINC
+#define PCINT16_IDX  	0
+
+#define DDR_SDA  	DDRC
+#define PORT_SDA 	PORTC
+#define PIN_SDA  	PINC
+#define SDA_IDX  	1
+
+#define DDR_PCINT17  	DDRC
+#define PORT_PCINT17 	PORTC
+#define PIN_PCINT17  	PINC
+#define PCINT17_IDX  	1
+
+#define DDR_PCINT18  	DDRC
+#define PORT_PCINT18 	PORTC
+#define PIN_PCINT18  	PINC
+#define PCINT18_IDX  	2
+
+#define DDR_PCINT19  	DDRC
+#define PORT_PCINT19 	PORTC
+#define PIN_PCINT19  	PINC
+#define PCINT19_IDX  	3
+
+#define DDR_PCINT20  	DDRC
+#define PORT_PCINT20 	PORTC
+#define PIN_PCINT20  	PINC
+#define PCINT20_IDX  	4
+
+#define DDR_PCINT21  	DDRC
+#define PORT_PCINT21 	PORTC
+#define PIN_PCINT21  	PINC
+#define PCINT21_IDX  	5
+
+#define DDR_PCINT22  	DDRC
+#define PORT_PCINT22 	PORTC
+#define PIN_PCINT22  	PINC
+#define PCINT22_IDX  	6
+
+#define DDR_PCINT23  	DDRC
+#define PORT_PCINT23 	PORTC
+#define PIN_PCINT23  	PINC
+#define PCINT23_IDX  	7
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_PCINT24  	DDRD
+#define PORT_PCINT24 	PORTD
+#define PIN_PCINT24  	PIND
+#define PCINT24_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_PCINT25  	DDRD
+#define PORT_PCINT25 	PORTD
+#define PIN_PCINT25  	PIND
+#define PCINT25_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_PCINT26  	DDRD
+#define PORT_PCINT26 	PORTD
+#define PIN_PCINT26  	PIND
+#define PCINT26_IDX  	2
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_PCINT27  	DDRD
+#define PORT_PCINT27 	PORTD
+#define PIN_PCINT27  	PIND
+#define PCINT27_IDX  	3
+
+#define DDR_OC1B  	DDRD
+#define PORT_OC1B 	PORTD
+#define PIN_OC1B  	PIND
+#define OC1B_IDX  	4
+
+#define DDR_PCINT28  	DDRD
+#define PORT_PCINT28 	PORTD
+#define PIN_PCINT28  	PIND
+#define PCINT28_IDX  	4
+
+#define DDR_OC1A  	DDRD
+#define PORT_OC1A 	PORTD
+#define PIN_OC1A  	PIND
+#define OC1A_IDX  	5
+
+#define DDR_PCINT29  	DDRD
+#define PORT_PCINT29 	PORTD
+#define PIN_PCINT29  	PIND
+#define PCINT29_IDX  	5
+
+#define DDR_ICP  	DDRD
+#define PORT_ICP 	PORTD
+#define PIN_ICP  	PIND
+#define ICP_IDX  	6
+
+#define DDR_OC2B  	DDRD
+#define PORT_OC2B 	PORTD
+#define PIN_OC2B  	PIND
+#define OC2B_IDX  	6
+
+#define DDR_PCINT30  	DDRD
+#define PORT_PCINT30 	PORTD
+#define PIN_PCINT30  	PIND
+#define PCINT30_IDX  	6
+
+#define DDR_OC2A  	DDRD
+#define PORT_OC2A 	PORTD
+#define PIN_OC2A  	PIND
+#define OC2A_IDX  	7
+
+#define DDR_PCINT31  	DDRD
+#define PORT_PCINT31 	PORTD
+#define PIN_PCINT31  	PIND
+#define PCINT31_IDX  	7
+
+
 #endif /* _AVR_IOMXX4_H_ */
Index: include/avr/iom8515.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom8515.h,v
retrieving revision 1.15
diff -u -r1.15 iom8515.h
--- include/avr/iom8515.h	17 Oct 2008 23:22:44 -0000	1.15
+++ include/avr/iom8515.h	26 Mar 2009 20:10:33 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Steinar Haugen
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -209,69 +210,88 @@
 /* Interrupt vectors */
 
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt Request 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		3
 #define TIMER1_CAPT_vect		_VECTOR(3)
 #define SIG_INPUT_CAPTURE1		_VECTOR(3)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		4
 #define TIMER1_COMPA_vect		_VECTOR(4)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(4)
 
 /* Timer/Counter1 Compare MatchB */
+#define TIMER1_COMPB_num 		5
 #define TIMER1_COMPB_vect		_VECTOR(5)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(5)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			6
 #define TIMER1_OVF_vect			_VECTOR(6)
 #define SIG_OVERFLOW1			_VECTOR(6)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			7
 #define TIMER0_OVF_vect			_VECTOR(7)
 #define SIG_OVERFLOW0			_VECTOR(7)
 
 /* Serial Transfer Complete */
+#define SPI_STC_num 			8
 #define SPI_STC_vect			_VECTOR(8)
 #define SIG_SPI				_VECTOR(8)
 
 /* UART, Rx Complete */
+#define USART_RX_num                    9
 #define USART_RX_vect                   _VECTOR(9)
+#define UART_RX_num                     9
 #define UART_RX_vect                    _VECTOR(9) /* For compatability only */
 #define SIG_UART_RECV                   _VECTOR(9) /* For compatability only */
 
 /* UART Data Register Empty */
+#define USART_UDRE_num                  10
 #define USART_UDRE_vect                 _VECTOR(10)
+#define UART_UDRE_num                   10
 #define UART_UDRE_vect                  _VECTOR(10) /* For compatability only */
 #define SIG_UART_DATA                   _VECTOR(10) /* For compatability only */
 
 /* UART, Tx Complete */
+#define USART_TX_num                    11
 #define USART_TX_vect                   _VECTOR(11)
+#define UART_TX_num                     11
 #define UART_TX_vect                    _VECTOR(11) /* For compatability only */
 #define SIG_UART_TRANS                  _VECTOR(11) /* For compatability only */
 
 /* Analog Comparator */
+#define ANA_COMP_num 			12
 #define ANA_COMP_vect			_VECTOR(12)
 #define SIG_COMPARATOR			_VECTOR(12)
 
 /* External Interrupt Request 2 */
+#define INT2_num 			13
 #define INT2_vect			_VECTOR(13)
 #define SIG_INTERRUPT2			_VECTOR(13)
 
 /* Timer 0 Compare Match */
+#define TIMER0_COMP_num 		14
 #define TIMER0_COMP_vect		_VECTOR(14)
 #define SIG_OUTPUT_COMPARE0		_VECTOR(14)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			15
 #define EE_RDY_vect			_VECTOR(15)
 #define SIG_EEPROM_READY		_VECTOR(15)
 
 /* Store Program Memory Ready */
+#define SPM_RDY_num 			16
 #define SPM_RDY_vect			_VECTOR(16)
 #define SIG_SPM_READY			_VECTOR(16)
 
@@ -633,4 +653,191 @@
 #define SIGNATURE_2 0x06
 
 
+/* Device Pin Definitions */
+#define DDR_AD0  	DDRA
+#define PORT_AD0 	PORTA
+#define PIN_AD0  	PINA
+#define AD0_IDX  	0
+
+#define DDR_AD1  	DDRA
+#define PORT_AD1 	PORTA
+#define PIN_AD1  	PINA
+#define AD1_IDX  	1
+
+#define DDR_AD2  	DDRA
+#define PORT_AD2 	PORTA
+#define PIN_AD2  	PINA
+#define AD2_IDX  	2
+
+#define DDR_AD3  	DDRA
+#define PORT_AD3 	PORTA
+#define PIN_AD3  	PINA
+#define AD3_IDX  	3
+
+#define DDR_AD4  	DDRA
+#define PORT_AD4 	PORTA
+#define PIN_AD4  	PINA
+#define AD4_IDX  	4
+
+#define DDR_AD5  	DDRA
+#define PORT_AD5 	PORTA
+#define PIN_AD5  	PINA
+#define AD5_IDX  	5
+
+#define DDR_AD6  	DDRA
+#define PORT_AD6 	PORTA
+#define PIN_AD6  	PINA
+#define AD6_IDX  	6
+
+#define DDR_AD7  	DDRA
+#define PORT_AD7 	PORTA
+#define PIN_AD7  	PINA
+#define AD7_IDX  	7
+
+#define DDR_OC0  	DDRB
+#define PORT_OC0 	PORTB
+#define PIN_OC0  	PINB
+#define OC0_IDX  	0
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	0
+
+#define DDR_T1  	DDRB
+#define PORT_T1 	PORTB
+#define PIN_T1  	PINB
+#define T1_IDX  	1
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	2
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	3
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	4
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	5
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	6
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	7
+
+#define DDR_A8  	DDRC
+#define PORT_A8 	PORTC
+#define PIN_A8  	PINC
+#define A8_IDX  	0
+
+#define DDR_A9  	DDRC
+#define PORT_A9 	PORTC
+#define PIN_A9  	PINC
+#define A9_IDX  	1
+
+#define DDR_A10  	DDRC
+#define PORT_A10 	PORTC
+#define PIN_A10  	PINC
+#define A10_IDX  	2
+
+#define DDR_A11  	DDRC
+#define PORT_A11 	PORTC
+#define PIN_A11  	PINC
+#define A11_IDX  	3
+
+#define DDR_A12  	DDRC
+#define PORT_A12 	PORTC
+#define PIN_A12  	PINC
+#define A12_IDX  	4
+
+#define DDR_A13  	DDRC
+#define PORT_A13 	PORTC
+#define PIN_A13  	PINC
+#define A13_IDX  	5
+
+#define DDR_A14  	DDRC
+#define PORT_A14 	PORTC
+#define PIN_A14  	PINC
+#define A14_IDX  	6
+
+#define DDR_A15  	DDRC
+#define PORT_A15 	PORTC
+#define PIN_A15  	PINC
+#define A15_IDX  	7
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_XCK  	DDRD
+#define PORT_XCK 	PORTD
+#define PIN_XCK  	PIND
+#define XCK_IDX  	4
+
+#define DDR_OC1A  	DDRD
+#define PORT_OC1A 	PORTD
+#define PIN_OC1A  	PIND
+#define OC1A_IDX  	5
+
+#define DDR_WR  	DDRD
+#define PORT_WR 	PORTD
+#define PIN_WR  	PIND
+#define WR_IDX  	6
+
+#define DDR_RD  	DDRD
+#define PORT_RD 	PORTD
+#define PIN_RD  	PIND
+#define RD_IDX  	7
+
+#define DDR_ICP  	DDRE
+#define PORT_ICP 	PORTE
+#define PIN_ICP  	PINE
+#define ICP_IDX  	0
+
+#define DDR_INT2  	DDRE
+#define PORT_INT2 	PORTE
+#define PIN_INT2  	PINE
+#define INT2_IDX  	0
+
+#define DDR_ALE  	DDRE
+#define PORT_ALE 	PORTE
+#define PIN_ALE  	PINE
+#define ALE_IDX  	1
+
+#define DDR_OC1B  	DDRE
+#define PORT_OC1B 	PORTE
+#define PIN_OC1B  	PINE
+#define OC1B_IDX  	2
+
+
 #endif /* _AVR_IOM8515_H_ */
Index: include/avr/iom48p.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom48p.h,v
retrieving revision 1.16
diff -u -r1.16 iom48p.h
--- include/avr/iom48p.h	11 Feb 2009 17:53:37 -0000	1.16
+++ include/avr/iom48p.h	26 Mar 2009 20:10:32 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2007 Atmel Corporation
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -781,30 +782,55 @@
 
 /* Interrupt Vectors */
 /* Interrupt Vector 0 is the reset vector. */
+#define INT0_num          1
 #define INT0_vect         _VECTOR(1)   /* External Interrupt Request 0 */
+#define INT1_num          2
 #define INT1_vect         _VECTOR(2)   /* External Interrupt Request 1 */
+#define PCINT0_num        3
 #define PCINT0_vect       _VECTOR(3)   /* Pin Change Interrupt Request 0 */
+#define PCINT1_num        4
 #define PCINT1_vect       _VECTOR(4)   /* Pin Change Interrupt Request 0 */
+#define PCINT2_num        5
 #define PCINT2_vect       _VECTOR(5)   /* Pin Change Interrupt Request 1 */
+#define WDT_num           6
 #define WDT_vect          _VECTOR(6)   /* Watchdog Time-out Interrupt */
+#define TIMER2_COMPA_num  7
 #define TIMER2_COMPA_vect _VECTOR(7)   /* Timer/Counter2 Compare Match A */
+#define TIMER2_COMPB_num  8
 #define TIMER2_COMPB_vect _VECTOR(8)   /* Timer/Counter2 Compare Match A */
+#define TIMER2_OVF_num    9
 #define TIMER2_OVF_vect   _VECTOR(9)   /* Timer/Counter2 Overflow */
+#define TIMER1_CAPT_num   10
 #define TIMER1_CAPT_vect  _VECTOR(10)  /* Timer/Counter1 Capture Event */
+#define TIMER1_COMPA_num  11
 #define TIMER1_COMPA_vect _VECTOR(11)  /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPB_num  12
 #define TIMER1_COMPB_vect _VECTOR(12)  /* Timer/Counter1 Compare Match B */ 
+#define TIMER1_OVF_num    13
 #define TIMER1_OVF_vect   _VECTOR(13)  /* Timer/Counter1 Overflow */
+#define TIMER0_COMPA_num  14
 #define TIMER0_COMPA_vect _VECTOR(14)  /* TimerCounter0 Compare Match A */
+#define TIMER0_COMPB_num  15
 #define TIMER0_COMPB_vect _VECTOR(15)  /* TimerCounter0 Compare Match B */
+#define TIMER0_OVF_num    16
 #define TIMER0_OVF_vect   _VECTOR(16)  /* Timer/Couner0 Overflow */
+#define SPI_STC_num       17
 #define SPI_STC_vect      _VECTOR(17)  /* SPI Serial Transfer Complete */
+#define USART_RX_num      18
 #define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
+#define USART_UDRE_num    19
 #define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
+#define USART_TX_num      20
 #define USART_TX_vect     _VECTOR(20)  /* USART Tx Complete */
+#define ADC_num           21
 #define ADC_vect          _VECTOR(21)  /* ADC Conversion Complete */
+#define EE_READY_num      22
 #define EE_READY_vect     _VECTOR(22)  /* EEPROM Ready */
+#define ANALOG_COMP_num   23
 #define ANALOG_COMP_vect  _VECTOR(23)  /* Analog Comparator */
+#define TWI_num           24
 #define TWI_vect          _VECTOR(24)  /* Two-wire Serial Interface */
+#define SPM_READY_num     25
 #define SPM_READY_vect    _VECTOR(25)  /* Store Program Memory Read */
 
 #define _VECTORS_SIZE (26 * 2)
@@ -865,4 +891,276 @@
 #define SIGNATURE_2 0x0A
 
 
+/* Device Pin Definitions */
+#define DDR_ICP1  	DDRB
+#define PORT_ICP1 	PORTB
+#define PIN_ICP1  	PINB
+#define ICP1_IDX  	0
+
+#define DDR_CLKO  	DDRB
+#define PORT_CLKO 	PORTB
+#define PIN_CLKO  	PINB
+#define CLKO_IDX  	0
+
+#define DDR_PCINT0  	DDRB
+#define PORT_PCINT0 	PORTB
+#define PIN_PCINT0  	PINB
+#define PCINT0_IDX  	0
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	1
+
+#define DDR_PCINT1  	DDRB
+#define PORT_PCINT1 	PORTB
+#define PIN_PCINT1  	PINB
+#define PCINT1_IDX  	1
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	2
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	2
+
+#define DDR_PCINT2  	DDRB
+#define PORT_PCINT2 	PORTB
+#define PIN_PCINT2  	PINB
+#define PCINT2_IDX  	2
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	3
+
+#define DDR_OC2A  	DDRB
+#define PORT_OC2A 	PORTB
+#define PIN_OC2A  	PINB
+#define OC2A_IDX  	3
+
+#define DDR_PCINT3  	DDRB
+#define PORT_PCINT3 	PORTB
+#define PIN_PCINT3  	PINB
+#define PCINT3_IDX  	3
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	4
+
+#define DDR_PCINT4  	DDRB
+#define PORT_PCINT4 	PORTB
+#define PIN_PCINT4  	PINB
+#define PCINT4_IDX  	4
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	5
+
+#define DDR_PCINT5  	DDRB
+#define PORT_PCINT5 	PORTB
+#define PIN_PCINT5  	PINB
+#define PCINT5_IDX  	5
+
+#define DDR_TOSC1  	DDRB
+#define PORT_TOSC1 	PORTB
+#define PIN_TOSC1  	PINB
+#define TOSC1_IDX  	6
+
+#define DDR_PCINT6  	DDRB
+#define PORT_PCINT6 	PORTB
+#define PIN_PCINT6  	PINB
+#define PCINT6_IDX  	6
+
+#define DDR_TOSC2  	DDRB
+#define PORT_TOSC2 	PORTB
+#define PIN_TOSC2  	PINB
+#define TOSC2_IDX  	7
+
+#define DDR_PCINT7  	DDRB
+#define PORT_PCINT7 	PORTB
+#define PIN_PCINT7  	PINB
+#define PCINT7_IDX  	7
+
+#define DDR_ADC0  	DDRC
+#define PORT_ADC0 	PORTC
+#define PIN_ADC0  	PINC
+#define ADC0_IDX  	0
+
+#define DDR_PCINT8  	DDRC
+#define PORT_PCINT8 	PORTC
+#define PIN_PCINT8  	PINC
+#define PCINT8_IDX  	0
+
+#define DDR_ADC1  	DDRC
+#define PORT_ADC1 	PORTC
+#define PIN_ADC1  	PINC
+#define ADC1_IDX  	1
+
+#define DDR_PCINT9  	DDRC
+#define PORT_PCINT9 	PORTC
+#define PIN_PCINT9  	PINC
+#define PCINT9_IDX  	1
+
+#define DDR_ADC2  	DDRC
+#define PORT_ADC2 	PORTC
+#define PIN_ADC2  	PINC
+#define ADC2_IDX  	2
+
+#define DDR_PCINT10  	DDRC
+#define PORT_PCINT10 	PORTC
+#define PIN_PCINT10  	PINC
+#define PCINT10_IDX  	2
+
+#define DDR_ADC3  	DDRC
+#define PORT_ADC3 	PORTC
+#define PIN_ADC3  	PINC
+#define ADC3_IDX  	3
+
+#define DDR_PCINT11  	DDRC
+#define PORT_PCINT11 	PORTC
+#define PIN_PCINT11  	PINC
+#define PCINT11_IDX  	3
+
+#define DDR_ADC4  	DDRC
+#define PORT_ADC4 	PORTC
+#define PIN_ADC4  	PINC
+#define ADC4_IDX  	4
+
+#define DDR_SDA  	DDRC
+#define PORT_SDA 	PORTC
+#define PIN_SDA  	PINC
+#define SDA_IDX  	4
+
+#define DDR_PCINT12  	DDRC
+#define PORT_PCINT12 	PORTC
+#define PIN_PCINT12  	PINC
+#define PCINT12_IDX  	4
+
+#define DDR_ADC5  	DDRC
+#define PORT_ADC5 	PORTC
+#define PIN_ADC5  	PINC
+#define ADC5_IDX  	5
+
+#define DDR_SCL  	DDRC
+#define PORT_SCL 	PORTC
+#define PIN_SCL  	PINC
+#define SCL_IDX  	5
+
+#define DDR_PCINT13  	DDRC
+#define PORT_PCINT13 	PORTC
+#define PIN_PCINT13  	PINC
+#define PCINT13_IDX  	5
+
+#define DDR_PCINT14  	DDRC
+#define PORT_PCINT14 	PORTC
+#define PIN_PCINT14  	PINC
+#define PCINT14_IDX  	6
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_PCINT16  	DDRD
+#define PORT_PCINT16 	PORTD
+#define PIN_PCINT16  	PIND
+#define PCINT16_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_PCINT17  	DDRD
+#define PORT_PCINT17 	PORTD
+#define PIN_PCINT17  	PIND
+#define PCINT17_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_PCINT18  	DDRD
+#define PORT_PCINT18 	PORTD
+#define PIN_PCINT18  	PIND
+#define PCINT18_IDX  	2
+
+#define DDR_PCINT19  	DDRD
+#define PORT_PCINT19 	PORTD
+#define PIN_PCINT19  	PIND
+#define PCINT19_IDX  	3
+
+#define DDR_OC2B  	DDRD
+#define PORT_OC2B 	PORTD
+#define PIN_OC2B  	PIND
+#define OC2B_IDX  	3
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_XCK  	DDRD
+#define PORT_XCK 	PORTD
+#define PIN_XCK  	PIND
+#define XCK_IDX  	4
+
+#define DDR_T0  	DDRD
+#define PORT_T0 	PORTD
+#define PIN_T0  	PIND
+#define T0_IDX  	4
+
+#define DDR_PCINT20  	DDRD
+#define PORT_PCINT20 	PORTD
+#define PIN_PCINT20  	PIND
+#define PCINT20_IDX  	4
+
+#define DDR_T1  	DDRD
+#define PORT_T1 	PORTD
+#define PIN_T1  	PIND
+#define T1_IDX  	5
+
+#define DDR_OC0B  	DDRD
+#define PORT_OC0B 	PORTD
+#define PIN_OC0B  	PIND
+#define OC0B_IDX  	5
+
+#define DDR_PCINT21  	DDRD
+#define PORT_PCINT21 	PORTD
+#define PIN_PCINT21  	PIND
+#define PCINT21_IDX  	5
+
+#define DDR_AIN0  	DDRD
+#define PORT_AIN0 	PORTD
+#define PIN_AIN0  	PIND
+#define AIN0_IDX  	6
+
+#define DDR_OC0A  	DDRD
+#define PORT_OC0A 	PORTD
+#define PIN_OC0A  	PIND
+#define OC0A_IDX  	6
+
+#define DDR_PCINT22  	DDRD
+#define PORT_PCINT22 	PORTD
+#define PIN_PCINT22  	PIND
+#define PCINT22_IDX  	6
+
+#define DDR_AIN1  	DDRD
+#define PORT_AIN1 	PORTD
+#define PIN_AIN1  	PIND
+#define AIN1_IDX  	7
+
+#define DDR_PCINT23  	DDRD
+#define PORT_PCINT23 	PORTD
+#define PIN_PCINT23  	PIND
+#define PCINT23_IDX  	7
+
+
 #endif  /* _AVR_IOM48P_H_ */
